package bfv.hardware;

/**
 * Created by AlFly on 14/11/15.
 */
public class HardwareCommand {

    private String code;
    private String message;
    private String params;
    private boolean addChecksum;
    private boolean addCRLF;

    public HardwareCommand(String code, String message) {
        this.code = code;
        this.message = message;
    }

    public String getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }

    public String getParams() {
        return params;
    }

    public void setParams(String params) {
        this.params = params;
    }

    public void setAddChecksum(boolean addChecksum){
        this.addChecksum = addChecksum;
    }

    public boolean isAddChecksum() {
        return addChecksum;


    }

    public boolean isAddCRLF() {
        return addCRLF;
    }

    public void setAddCRLF(boolean addCRLF) {
        this.addCRLF = addCRLF;
    }

    public String toString(){
        if(params != null){
            return message + " > $" + code + " {params}*" ;
        }
        return message + " > $" + code + "*" ;
    }
}
