package test;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.Path2D;

/**
 * Created by IntelliJ IDEA.
 * User: Alistair
 * Date: 02/05/2011
 * Time: 9:21:42 PM
 * To change this template use File | Settings | File Templates.
 */
public class VarioPanel extends JPanel {

    public double[] var1Data;
    public double[] var2Data;
    public double[] var3Data;
    public double[] altData;
    public double[] altData2;
    public int i = 0;
    int size = 400;
    int xStep = 1;


    public boolean dataFull;


    public VarioPanel() {
        super();

        var1Data = new double[size];
        var2Data = new double[size];
        var3Data = new double[size];
        altData = new double[size];
        altData2 = new double[size];
    }

    public void addData(double var1, double var2, double var3, double alt, double alt2){
         if(dataFull){

        }

        var1Data[i] = var1;
        var2Data[i] = var2;
        var3Data[i] = var3;
        altData[i] = alt;
        altData2[i] = alt2;

        i++;
        if(i == size){
            i = 0;
            dataFull = true;
        }


    }







    public void paintComponent(Graphics g){
        Graphics2D g2 = (Graphics2D)g;


        double min2 = Math.abs(getMinValue(var2Data, new double[]{}));
        double max2 = Math.abs(getMaxValue(var2Data, new double[]{}));

        double mag2 = Math.max(min2, max2);

        double min1 = Math.abs(getMinValue(var1Data, new double[]{}));
        double max1 = Math.abs(getMaxValue(var1Data, new double[]{}));

        double mag1 = Math.max(min1, max1);

        double mag = Math.max(mag1, mag2);

        if(mag < 1.5){
            mag = 1.5;
        }

//        double minAlt = getMinValue(altDaltData2ata, );
//        double maxAlt = getMaxValue(altData, altData2);

        double minAlt = getMinValue(altData,altData );
        double maxAlt = getMaxValue(altData, altData);

        int j = i-1;
        if(j < 0){
            j = size-1;
        }
    
        double currentAlt = altData[j];
        double scale = Math.max(maxAlt - currentAlt, currentAlt - minAlt);
        if(scale < 0.5){
            scale = 0.5;
        }


        //alt
        g2.setColor(Color.white);

        Path2D.Double altShape = new Path2D.Double();
        int xAlt = 50;
        altShape.moveTo(50.0,110.0);
        for(int p = i; p > i-size + 1; p--){
            int c = p-1;
            if(c < 0){
                c = c + size;

            }

            double yAlt = 110.0+(currentAlt - altData[c])*100/scale;



            altShape.lineTo(xAlt, yAlt);

            xAlt+=xStep;





        }
        altShape.lineTo(xAlt,10);
        altShape.lineTo(50,10);
        altShape.closePath();
        g2.fill(altShape);

        //alt2

        g2.setColor(Color.blue);
        Path2D.Double alt2Shape = new Path2D.Double();
                 xAlt = 50;
        alt2Shape.moveTo(50.0,110.0);
        for(int p = i; p > i-size + 1; p--){
            int c = p-1;
            if(c < 0){
                c = c + size;

            }

            double yAlt = 110.0+(currentAlt - altData2[c])*100/scale;



            alt2Shape.lineTo(xAlt, yAlt);

            xAlt+=xStep;





        }

        g2.draw(alt2Shape);


        g2.setColor(Color.black);
        g2.drawRect(50,10,xStep*size,200);
       
//        System.out.println(mag);
        g2.setColor(Color.blue);
        
        for(int y = 0; y < mag; y++){
            int yPix = (int)(y * 100/mag);
            g2.drawLine(50,110 - yPix , 60, 110 - yPix);
            g2.drawString("" + y, 65, 110-yPix + 5);

            if(y != 0){
                g2.drawLine(50,110 + yPix , 60, 110 + yPix);
                g2.drawString("" + y, 65, 110 + yPix + 5);
            }



        }

        //var 2
        g2.setColor(Color.blue);

        int x = 50;
        boolean doneFirst = false;
        for(int p = i; p > i-size + 1; p--){

            int c = p-1;
            if(c < 0){
                c = c + size;

            }

            double var2 = var2Data[c];
            double var2Last = 0.0;
            if(c-1 < 0){
                var2Last = var2Data[size - 1];

            }
            else{
               var2Last = var2Data[c - 1];
            }
            if(!doneFirst){
                //var2Last = var2;
                g2.drawString("Var2",20,110 - (int) (var2 * 100/mag) + 5);
            }

         //   g2.drawLine(x, 110 - (int) (var2 * 100/mag)  ,x+xStep,110 - (int) (var2Last * 100/mag));
            x+=xStep;
            doneFirst = true;
        }

        //var 1
        g2.setColor(Color.pink);

        int x1 = 50;
        boolean doneFirst1 = false;
        for(int p = i; p > i-size + 1; p--){

            int c = p-1;
            if(c < 0){
                c = c + size;

            }

            double var1 = var1Data[c];
            double var1Last = 0.0;
            if(c-1 < 0){
                var1Last = var1Data[size - 1];

            }
            else{
               var1Last = var1Data[c - 1];
            }
            if(!doneFirst1){
                //var2Last = var2;
                g2.drawString("Var1",20,110 - (int) (var1 * 100/mag) + 5);
            }

        //    g2.drawLine(x1, 110 - (int) (var1 * 100/mag)  ,x1+xStep,110 - (int) (var1Last * 100/mag));
            x1+=xStep;
            doneFirst1 = true;
        }

         //var 3
        g2.setColor(Color.green);

        int x2 = 50;
        boolean doneFirst2 = false;
        for(int p = i; p > i-size + 1; p--){

            int c = p-1;
            if(c < 0){
                c = c + size;

            }

            double var3 = var3Data[c];
            double var3Last = 0.0;
            if(c-1 < 0){
                var3Last = var3Data[size - 1];

            }
            else{
               var3Last = var3Data[c - 1];
            }
            if(!doneFirst2){
                //var2Last = var2;
                g2.drawString("Var3",20,110 - (int) (var3 * 100/mag) + 5);
            }

           // g2.drawLine(x2, 110 - (int) (var3 * 100/mag)  ,x2+xStep,110 - (int) (var3Last * 100/mag));
            x2+=xStep;
            doneFirst2 = true;
        }









    }

    public static double getMaxValue(double[] val, double[] val2){
        double max = Double.MIN_VALUE;
        for (int i = 0; i < val.length; i++) {
            double v = val[i];
            if(v > max){
                max = v;
            }
        }
        for (int i = 0; i < val2.length; i++) {
            double v = val2[i];
            if(v > max){
               max = v;
           }
        }
        return max;

    }

    public static double getMinValue(double[] val, double val2[]){
        double min = Double.MAX_VALUE;
        for (int i = 0; i < val.length; i++) {
            double v = val[i];
            if(v < min){
                min = v;
            }
        }

        for (int i = 0; i < val2.length; i++) {
            double v = val2[i];
            if(v < min){
                min = v;
            }
        }
        return min;

    }
}

